searchData={"items":[{"type":"module","title":"AshNeo4j.Cypher","doc":"Ash Neo4j cypher functions","ref":"AshNeo4j.Cypher.html"},{"type":"function","title":"AshNeo4j.Cypher.expression/4","doc":"Converts a node variable, label and optional properties to cypher expression","ref":"AshNeo4j.Cypher.html#expression/4"},{"type":"function","title":"Examples - AshNeo4j.Cypher.expression/4","doc":"```\niex> AshNeo4j.Cypher.expression(:s, \"name\", \"in\", \"[Bill Nighy]\")\n\"s.name in [Bill Nighy]\"\niex> AshNeo4j.Cypher.expression(:s, \"name\", \"in\", \"[]\")\n\"s.name IS NOT NULL\"\n```","ref":"AshNeo4j.Cypher.html#expression/4-examples"},{"type":"function","title":"AshNeo4j.Cypher.node/3","doc":"Converts a node variable, label and optional properties to cypher node.","ref":"AshNeo4j.Cypher.html#node/3"},{"type":"function","title":"Examples - AshNeo4j.Cypher.node/3","doc":"```\niex> AshNeo4j.Cypher.node(:s, :Actor)\n\"(s:Actor)\"\niex> AshNeo4j.Cypher.node(:s, :Actor, %{name: \"Bill Nighy\"})\n\"(s:Actor {name: 'Bill Nighy'})\"\n```","ref":"AshNeo4j.Cypher.html#node/3-examples"},{"type":"function","title":"AshNeo4j.Cypher.properties/1","doc":"Converts a map to a cypher properties string.\nThe map is converted to a string in the format `{key1: value1, key2: value2}`.\nThis is used to create nodes in Neo4j.","ref":"AshNeo4j.Cypher.html#properties/1"},{"type":"function","title":"Examples - AshNeo4j.Cypher.properties/1","doc":"```\niex> AshNeo4j.Cypher.properties(%{name: \"Bill Nighy\", born: 1949, bafta_winner: true})\n\"{name: 'Bill Nighy', born: 1949, bafta_winner: true}\"\n```","ref":"AshNeo4j.Cypher.html#properties/1-examples"},{"type":"function","title":"AshNeo4j.Cypher.relationship/1","doc":"Converts a node_relationship tuple to cypher clause, ignoring the label","ref":"AshNeo4j.Cypher.html#relationship/1"},{"type":"function","title":"Examples - AshNeo4j.Cypher.relationship/1","doc":"```\niex> AshNeo4j.Cypher.relationship({:movies, :ACTED_IN, :outgoing})\n\"-[r:ACTED_IN]->\"\niex> AshNeo4j.Cypher.relationship(nil)\n\"-[r]-\"\n```","ref":"AshNeo4j.Cypher.html#relationship/1-examples"},{"type":"function","title":"AshNeo4j.Cypher.relationship/3","doc":"Converts a relationship variable, label and optional direction to cypher relationship.","ref":"AshNeo4j.Cypher.html#relationship/3"},{"type":"function","title":"Examples - AshNeo4j.Cypher.relationship/3","doc":"```\niex> AshNeo4j.Cypher.relationship(:r, :ACTED_IN, :outgoing)\n\"-[r:ACTED_IN]->\"\niex> AshNeo4j.Cypher.relationship(:r, :ACTED_IN, :incoming)\n\"<-[r:ACTED_IN]-\"\niex> AshNeo4j.Cypher.relationship(:r, :KNOWS)\n\"-[r:KNOWS]-\"\n```","ref":"AshNeo4j.Cypher.html#relationship/3-examples"},{"type":"function","title":"AshNeo4j.Cypher.run/1","doc":"Runs some cypher","ref":"AshNeo4j.Cypher.html#run/1"},{"type":"function","title":"Examples - AshNeo4j.Cypher.run/1","doc":"```\niex> cypher = \"CREATE (n:Actor {name: 'Bill Nighy', born: 1949, bafta_winner: true}) RETURN n\"\niex> {result, _} = AshNeo4j.Cypher.run(cypher)\niex> result\n:ok\n```","ref":"AshNeo4j.Cypher.html#run/1-examples"},{"type":"module","title":"AshNeo4j.DataLayer","doc":"Ash DataLayer for Neo4j","ref":"AshNeo4j.DataLayer.html"},{"type":"function","title":"AshNeo4j.DataLayer.filter_matches/3","doc":"","ref":"AshNeo4j.DataLayer.html#filter_matches/3"},{"type":"macro","title":"AshNeo4j.DataLayer.neo4j/1","doc":"","ref":"AshNeo4j.DataLayer.html#neo4j/1"},{"type":"module","title":"AshNeo4j.DataLayer.Info","doc":"Introspection helpers for AshNeo4j.DataLayer","ref":"AshNeo4j.DataLayer.Info.html"},{"type":"function","title":"AshNeo4j.DataLayer.Info.convert_to_property_name/2","doc":"Converts an attribute name to a node property name string, translating if necessary\nThe attribute name can be an Ash.Query.Ref or atom","ref":"AshNeo4j.DataLayer.Info.html#convert_to_property_name/2"},{"type":"function","title":"AshNeo4j.DataLayer.Info.label/1","doc":"","ref":"AshNeo4j.DataLayer.Info.html#label/1"},{"type":"function","title":"AshNeo4j.DataLayer.Info.node_relationship/2","doc":"","ref":"AshNeo4j.DataLayer.Info.html#node_relationship/2"},{"type":"function","title":"AshNeo4j.DataLayer.Info.relate/1","doc":"","ref":"AshNeo4j.DataLayer.Info.html#relate/1"},{"type":"function","title":"AshNeo4j.DataLayer.Info.relationship/3","doc":"Returns any matching Ash.Resource.Info relationship given relationship and destination node labels","ref":"AshNeo4j.DataLayer.Info.html#relationship/3"},{"type":"function","title":"AshNeo4j.DataLayer.Info.store/1","doc":"","ref":"AshNeo4j.DataLayer.Info.html#store/1"},{"type":"function","title":"AshNeo4j.DataLayer.Info.translate/1","doc":"","ref":"AshNeo4j.DataLayer.Info.html#translate/1"},{"type":"module","title":"AshNeo4j.Neo4jHelper","doc":"AshNeo4j DataLayer Neo4j Helper","ref":"AshNeo4j.Neo4jHelper.html"},{"type":"function","title":"AshNeo4j.Neo4jHelper.create_node/2","doc":"Creates a neo4j node with label and properties","ref":"AshNeo4j.Neo4jHelper.html#create_node/2"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.create_node/2","doc":"```\niex> {result, _} = AshNeo4j.Neo4jHelper.create_node(:Actor, %{name: \"Bill Nighy\"})\niex> result\n:ok\n```","ref":"AshNeo4j.Neo4jHelper.html#create_node/2-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.delete_all/0","doc":"Delete all neo4j nodes and relationships","ref":"AshNeo4j.Neo4jHelper.html#delete_all/0"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.delete_all/0","doc":"```\niex> {result, _} = AshNeo4j.Neo4jHelper.delete_all()\niex> result\n:ok\n```","ref":"AshNeo4j.Neo4jHelper.html#delete_all/0-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.merge_node/2","doc":"Creates a neo4j node with label and properties","ref":"AshNeo4j.Neo4jHelper.html#merge_node/2"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.merge_node/2","doc":"```\niex> {result, _} = AshNeo4j.Neo4jHelper.merge_node(:Actor, %{name: \"Bill Nighy\", born: 1949})\niex> result\n:ok\n```","ref":"AshNeo4j.Neo4jHelper.html#merge_node/2-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.nodes_relate_how?/6","doc":"Tests if two nodes are related with a relationship type","ref":"AshNeo4j.Neo4jHelper.html#nodes_relate_how?/6"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.nodes_relate_how?/6","doc":"```\niex> AshNeo4j.Neo4jHelper.create_node(:Actor, %{name: \"Bill Nighy\", born: 1949})\niex> AshNeo4j.Neo4jHelper.create_node(:Movie, %{title: \"Love Actually\"})\niex> AshNeo4j.Neo4jHelper.relate_nodes(:Actor, %{name: \"Bill Nighy\"}, :Movie, %{title: \"Love Actually\"}, :ACTED_IN, :outgoing)\niex> AshNeo4j.Neo4jHelper.nodes_relate_how?(:Actor, %{name: \"Bill Nighy\"}, :Movie, %{title: \"Love Actually\"}, :ACTED_IN, :outgoing)\ntrue\n```","ref":"AshNeo4j.Neo4jHelper.html#nodes_relate_how?/6-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.read_nodes/2","doc":"Reads nodes from Neo4j, given label and optionally properties","ref":"AshNeo4j.Neo4jHelper.html#read_nodes/2"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.read_nodes/2","doc":"```\niex> AshNeo4j.Neo4jHelper.create_node(:Actor, %{name: \"Bill Nighy\", born: 1949})\niex> {:ok, %{records: records}} = AshNeo4j.Neo4jHelper.read_nodes(:Actor, %{name: \"Bill Nighy\"})\niex> length(records)\n1\n```","ref":"AshNeo4j.Neo4jHelper.html#read_nodes/2-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.relate_nodes/6","doc":"Relates two nodes with a relationship type","ref":"AshNeo4j.Neo4jHelper.html#relate_nodes/6"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.relate_nodes/6","doc":"```\niex> AshNeo4j.Neo4jHelper.create_node(:Actor, %{name: \"Bill Nighy\", born: 1949})\niex> AshNeo4j.Neo4jHelper.create_node(:Movie, %{title: \"Love Actually\"})\niex> {result, _} = AshNeo4j.Neo4jHelper.relate_nodes(:Actor, %{name: \"Bill Nighy\"}, :Movie, %{title: \"Love Actually\"}, :ACTED_IN, :outgoing)\niex> result\n:ok\n```","ref":"AshNeo4j.Neo4jHelper.html#relate_nodes/6-examples"},{"type":"module","title":"AshNeo4j.QueryHelper","doc":"AshNeo4j DataLayer QueryHelper","ref":"AshNeo4j.QueryHelper.html"},{"type":"function","title":"AshNeo4j.QueryHelper.query_nodes/1","doc":"Queries nodes, using Ash.Query","ref":"AshNeo4j.QueryHelper.html#query_nodes/1"},{"type":"extras","title":"Guide","doc":"# AshNeo4j\n\n[![Module Version](https://img.shields.io/hexpm/v/ash_neo4j)](https://hex.pm/packages/ash_neo4j)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen)](https://hexdocs.pm/ash_neo4j/)\n[![License](https://img.shields.io/hexpm/l/ash_neo4j)](https://github.com/diffo-dev/ash_neo4j/blob/master/LICENSE.md)\n\nAsh DataLayer for Neo4j, configurable using a simple DSL","ref":"readme.html"},{"type":"extras","title":"Installation - Guide","doc":"Add to the deps:\n\n```elixir\ndef deps do\n  [\n    {:ash_neo4j, \"~> 0.1.1\"},\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Guide","doc":"Configure `AshNeo4j.DataLayer` as `data_layer:` within `use Ash.Resource` options:\n\n```elixir\n  use Ash.Resource,\n    data_layer: AshNeo4j.DataLayer\n```","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - Guide","doc":"Each Ash.Resource requires configuration of its AshNeo4j.DataLayer. An example Comment resource is given below, it can belong to a Post resource.\n\n```elixir\ndefmodule Comment.Resource do\n  use Ash.Resource,\n    data_layer: AshNeo4j.DataLayer\n\n  neo4j do\n    label :Comment\n    store [:id, :title]\n    translate id: :uuid\n    relate [{:post, :BELONGS_TO, :outgoing}]\n  end\n\n  actions do\n    default_accept(:*)\n    defaults([:create, :read, :update, :destroy])\n  end\n\n  attributes do\n    uuid_primary_key(:id)\n    attribute(:title, :string, public?: true)\n  end\n\n  relationships do\n    belongs_to(:post, Post, public?: true)\n  end\nend\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Label - Guide","doc":"The DSL is used to label the Ash Resource's underlying graph node.\n\n```elixir\n  neo4j do\n    label :Comment\n  end\n```","ref":"readme.html#label"},{"type":"extras","title":"Store - Guide","doc":"The DSL is used to store the Ash Resource's attributes as node properties, without translation.\n```elixir\n  neo4j do\n    store [:id, :title, :score, :public, :unique]\n  end\n```","ref":"readme.html#store"},{"type":"extras","title":"Translate - Guide","doc":"The DSL may be used to translate the Ash Resource's attributes to node properties.\n```elixir\n  neo4j do\n    translate id: :uuid\n  end\n```","ref":"readme.html#translate"},{"type":"extras","title":"Relate - Guide","doc":"The DSL is used to direct any node relationships.\n```elixir\n  neo4j do\n    relate [{:post, :BELONGS_TO, :outgoing}]\n  end\n```","ref":"readme.html#relate"},{"type":"extras","title":"Installing Neo4j and Configuring Boltx - Guide","doc":"ash_neo4j uses [neo4j](https://github.com/neo4j/neo4j) which must be installed and running.\n\nYour Ash application needs to configure, start and supervise [boltx](https://github.com/sagastume/boltx), see [boltx documentation](https://hexdocs.pm/boltx/). Make sure to configure any required authorisation.\n\nI've used Neo4j community edition 4.4 (bolt 4.4) and to connect using boltx I needed to also set the environment variable ```BOLT_VERSIONS=4.4``` to steer [bolt protocol handshake] (https://neo4j.com/docs/bolt/current/bolt/handshake).","ref":"readme.html#installing-neo4j-and-configuring-boltx"},{"type":"extras","title":"Limitations and Future Work - Guide","doc":"Currently ash_neo4j only supports Ash read actions, with some limited support for relationships. Support for create, update and destroy actions is next.\n\nCollaboration on ash_neo4j welcome via github, please use discussions and/or issues as appropriate.","ref":"readme.html#limitations-and-future-work"},{"type":"extras","title":"Acknowledgements - Guide","doc":"Thanks to the [Ash Core](https://github.com/ash-project) for [ash](https://github.com/ash-project/ash) 🚀, including [ash_csv](https://github.com/vonagam/ash_jason) which was an exemplar.\n\nThanks to [Sagastume](https://github.com/sagastume) for [boltx](https://github.com/tiagodavi/ex4j) which AFAIK was based on [bolt_sips](https://github.com/florinpatrascu/bolt_sips) by [Florin Patrascu](https://github.com/florinpatrascu).\n\nThanks to the [Neo4j Core](https://github.com/neo4j) for [neo4j](https://github.com/neo4j/neo4j) which pioneered graph databases.","ref":"readme.html#acknowledgements"},{"type":"extras","title":"Links - Guide","doc":"[Diffo.dev](https://www.diffo.dev)\n[Neo4j Deployment Centre](https://neo4j.com/deployment-center/).","ref":"readme.html#links"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2025 Matthew Graham Beanland\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"DSL","title":"neo4j - dsl-ashneo4j-datalayer","doc":"","ref":"dsl-ashneo4j-datalayer.html#neo4j"},{"type":"DSL","title":"neo4j.label - dsl-ashneo4j-datalayer","doc":"The node label","ref":"dsl-ashneo4j-datalayer.html#neo4j-label"},{"type":"DSL","title":"neo4j.store - dsl-ashneo4j-datalayer","doc":"The attributes to be stored as node properties, without translation","ref":"dsl-ashneo4j-datalayer.html#neo4j-store"},{"type":"DSL","title":"neo4j.translate - dsl-ashneo4j-datalayer","doc":"Optional attribute to node property translations","ref":"dsl-ashneo4j-datalayer.html#neo4j-translate"},{"type":"DSL","title":"neo4j.relate - dsl-ashneo4j-datalayer","doc":"Optional list of node relationships, as tuples of {relationship_name, edge_label, edge_direction}","ref":"dsl-ashneo4j-datalayer.html#neo4j-relate"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}